#include <stdlib.h>
#include "defines.h"
#include "xy.h"
#include "xyz.h"
#include "images.h"
#include "mesh.h"
typedef uns char byte;
byte ntitap=1,fileopen=0;
/*-----*/
void mesh::DUMP(char*fn){FILE*F=fopen(fn,"w"); int i;
fprintf(F,"fac: %p: ",fac);
for(i=0;i<nf;i++) fprintf(F,"%2d: %p=%2d (%d)/",i,fac[i].q,fac[i].q-pts,fac[i].n); fprintf(F,"\n");
fprintf(F,"pts: %p: ",pts);
for(i=0;i<nq;i++) fprintf(F,"%2d: %p=%2d /",i,pts[i].p,pts[i].p-point); fprintf(F,"\n");
fprintf(F,"points: %p: ",pts);
for(i=0;i<np;i++) fprintf(F,"%2d: {%g,%g,%g} /",i,point[i].a.x,point[i].a.y,point[i].a.z);
fprintf(F,"\n"); fclose(F);}
/*-----*/
#define det3(A,B,C,D,E,F,G,H,I) (A*(E*I-H*F)+D*(H*C-B*I)+G*(B*F-E*C))
/*-----*/
//double eqnsolve2(double ax,double ay,double bx,double by,double a,double b,
//  double&A,double&B){double det; if((det=ax*by-bx*ay)==0) return det;
//A=(by*a-ay*b)/det; B=(ax*b-bx*a)/det; return det; }
/*-----*/
void eqnsolve34(double ax,double ay,double az,double a,
					 double bx,double by,double bz,double b,
					 double cx,double cy,double cz,double c,
					 double &A,double &B,double &C,double&det){
det=det3(az,ax,ay,bz,bx,by,cz,cx,cy);
A  =det3(a ,ay,az,b ,by,bz,c ,cy,cz);
B  =det3(ax,a ,az,bx,b ,bz,cx,c ,cz);
C  =det3(ax,ay,a ,bx,by,b ,cx,cy,c );}
/*-----*/
double eqnsolve3(double ax,double ay,double az,double a,
					  double bx,double by,double bz,double b,
					  double cx,double cy,double cz,double c,
					  double &A,double &B,double &C){double  det;
if(det=det3(az,ax,ay,bz,bx,by,cz,cx,cy),det*det<1e-40) return 0;
	  A=det3(a ,ay,az,b ,by,bz,c ,cy,cz)/det;
	  B=det3(ax,a ,az,bx,b ,bz,cx,c ,cz)/det;
	  C=det3(ax,ay,a ,bx,by,b ,cx,cy,c )/det; return det;}
/*-----*//* the device context dc must still be there whenthe pen is deleted */
PEN::PEN(HDC dc,COLORREF col){d=dc; pen=CreatePen(0,1,col); old=SelectObject(dc,pen);};
PEN::~PEN(){SelectObject(d,old); DeleteObject(pen);};
/*-----*/
void SetTitle(HWND wn,char*S){SendMessage(wn,WM_SETTEXT,0,(long)S);}
/*-----*/
void GetTitle(HWND wn,char*S,long n){SendMessage(wn,WM_GETTEXT,n,(long)S);}
/*-----*/
double xb,yb,zb,xs,ys,zs; /* how to scale objects to current viewpoint */
double Sx,Sy,Sz,Cx,Cy,Cz; /* sin & cos of rotation angles */
double ub,vb,us,vs; /* how to scale texture map display */
int hite,wide; char scaled=0,texscaled=0,showpts=0,rerot=1;
//xyz Llm,Ulm,llm,ulm; /* limits of what to display */
xyz rotation,offset,screenmid(0,0,0); /* camera info */
xy texLlm,texUlm,texllm,texulm; /* limits of what to display */
xy texaxle; /* re rotating texture map parts */
/*-----*/
xyz rotate(xyz W){double w;
w=Cx*W.y-Sx*W.z; W.z=Sx*W.y+Cx*W.z; W.y=w;
w=Cy*W.z-Sy*W.x; W.x=Sy*W.z+Cy*W.x; W.z=w;
w=Cz*W.x-Sz*W.y; W.y=Sz*W.x+Cz*W.y; W.x=-w; return W;}
/*-----*/
xyz unrotate(xyz W){double w; W.x=-W.x; /* to cure the mirror-image fault */
w=Cz*W.x+Sz*W.y; W.y=-Sz*W.x+Cz*W.y; W.x=w;
w=Cy*W.z+Sy*W.x; W.x=-Sy*W.z+Cy*W.x; W.z=w;
w=Cx*W.y+Sx*W.z; W.z=-Sx*W.y+Cx*W.z; W.y=w; return W;}
/*-----*/
inline xyz revx(xyz w){return xyz(-w.x,w.y,w.z);}
/*-----*/
xyz scale(xyz W){W=  W-revx(offset); return xyz(W.x*xs+xb,hite-(W.y*ys+yb),W.z*zs+zb);}
xyz toscr(xyz W){W=rotate(W-offset); return xyz(W.x*xs+xb,hite-(W.y*ys+yb),W.z*zs+zb);}
xyz unscale(xyz W){return xyz((W.x-xb)/xs,(hite-W.y-yb)/ys,(W.z-zb)/zs)+revx(offset);};
xyz fromscr(xyz W){xyz Z((W.x-xb)/xs,(hite-W.y-yb)/ys,(W.z-zb)/zs); return unrotate(Z)+offset;};
/*-----*/
xy texscale(xy W){return xy(W.x*us+ub,W.y*vs+vb);} /* VT values to pixels */
xy untexscale(xy W){W=xy((W.x-ub)/us,(W.y-vb)/vs); return W;}; /* pixels to VT values */
/*-----*/
void Linexy(HDC dc,xyz A,xyz B){xyz C; MoveToEx(dc,A.x,A.y,0); LineTo(dc,B.x,B.y);}
/*-----*/
void Linezy(HDC dc,xyz A,xyz B){xyz C; MoveToEx(dc,A.z,A.y,0); LineTo(dc,B.z,B.y);}
/*-----*/
void Linetex(HDC dc,xy a,xy b){
a=texscale(a); b=texscale(b); MoveToEx(dc,a.x,a.y,0); LineTo(dc,b.x,b.y);}
/*-----*/
void Linetex(HDC dc,Texp*A,Texp*B){xy a=A?A->a:xy(0,0),b=B?B->a:xy(0,0);
a=texscale(a); b=texscale(b); MoveToEx(dc,a.x,a.y,0); LineTo(dc,b.x,b.y);}
/*-----*/
void Point::draw(HDC dc,byte xy,COLORREF c,int n){int i,j;
for(i=1-n;i<n;i++) for(j=1-n;j<n;j++) SetPixel(dc,(xy?r.x:r.z)+i,r.y+j,c);};
/*-----*/
void draw(xy t,HDC dc,COLORREF c,int n){int i,j;
for(i=1-n;i<n;i++) for(j=1-n;j<n;j++) SetPixel(dc,t.x+i,t.y+j,c);};
/*-----*/
void texdraw(HDC dc,xy T,COLORREF c,int n){int i,j;
for(i=1-n;i<n;i++) for(j=1-n;j<n;j++) SetPixel(dc,T.x+i,T.y+j,c);};
/*-----*/
void fcinfo::texdraw(HDC dc,COLORREF c,int n){if(t) {xy T=texscale(t->a); ::texdraw(dc,T,c,n);}}
/*-----*/
xyz Face::midr(){long k; xyz W(0,0,0); for(k=0;k<n;k++) W=W+q[k].p->r; return n?W/n:W;}
/*-----*/
xyz Face::edgemidr(int i){return !q?xyz(0,0,0):(q[i].p->r+q[(i+1)%n].p->r)*.5;}
/*-----*/
xy Face::midrtex(){long k; xy W(0,0); Texp*t; for(k=0;k<n;k++) if(t=q[k].t,t) W=W+t->a; return W/n;}
/*-----*/
void Face::draw(HDC dc,byte xy,int we){fcinfo*F=q; if(!F) return; long j,m=n;
if(we<0) for(j=0;j<m;j++) (xy?Linexy:Linezy)(dc,F[j].p->r,F[j==m-1?0:j+1].p->r);
else if(we<0?0:we<m) (xy?Linexy:Linezy)(dc,F[we].p->r,F[we==m-1?0:we+1].p->r);}
/*-----*/
mesh*OB=0; HWND Wn=0; long pdragging=-1;
/*-----*/
#define badaddr(p) (!IsValidAddress((char*)(p)))
int IsValidAddress(char*Ptr) {if(!Ptr) return 0;
try {volatile char c=*Ptr; *Ptr=c; return 1;} catch (...) {return 0;}}
/*-----*/
#define badnz(p) (!IsValidAddressOrZero((char*)(p)))
int IsValidAddressOrZero(char*Ptr) {if(!Ptr) return 1;
try {volatile char c=*Ptr; *Ptr=c; return 1;} catch (...) {return 0;}}
/*-----*/
mesh::mesh(){initialize();}
/*-----*/
void mesh::initialize(int j){if(j) delarrays();
setmem(this,sizeof(mesh),0); selface=selpoint=seltexp=-1;};
/*-----*/
void mesh::delarrays(){altered=1;
FF(fac); FF(point); FF(pts); FF(mat); FF(d); FF(t); FF(tma); FF(prt); FF(mtllib);}
/*-----*/
void far*Farmalloc(unsigned long n){void far*q=farmalloc(n);
if(!q) if(n) MessageBox(0,"I can't get enough memory","farmalloc",OUCH); return q;}
/*-----*/
void far*Farrealloc(void *p,unsigned long n,char*name){void far*q=farrealloc(p,n);
if(!q) if(n) MessageBox(0,"I can't get enough memory",name,OUCH); return q;}
/*-----*/
static char*nspac="I ran out of space when wanting more room for";
/*-----*/
int mesh::setnp_(int x,int k) {if(k?x==np_:x<=np_) return 1; Point*pp=point;
void*v=FR(point,Point,np_=x,"point"); if(!v) if(x) MessageBox(0,"points",nspac,OUCH);
int i; if(v) if(pp!=point) for(i=0;i<nq;i++) pts[i].p=point+(pts[i].p-pp); return !!v;}
/*-----*/
int mesh::setnt_(int x,int k) {if(k?x==nt_:x<=nt_) return 1; Texp*tt=t;
void*v=FR(t,Texp,nt_=x,"t"); if(!v) if(x) MessageBox(0,"texture map coords",nspac,OUCH);
int i; if(v) if(tt!=t) for(i=0;i<nq;i++) if(pts[i].t) pts[i].t=t+(pts[i].t-tt); return !!v;}
/*-----*/
int mesh::setnd_(int x,int k) {if(k?x==nd_:x<=nd_) return 1; xyz*dd=d;
void*v=FR(d,xyz,nd_=x,"d");  if(!v) if(x) MessageBox(0,"normals",nspac,OUCH);
int i; if(v) if(dd!=d) for(i=0;i<nq;i++) if(pts[i].d) pts[i].d=d+(pts[i].d-dd); return !!v;}
/*-----*/
int mesh::setnq_(int x,int k) {if(k?x==nq_:x<=nq_) return 1; fcinfo*qq=pts;
void*v=FR(pts,fcinfo,nq_=x,"q"); if(!v) if(x) MessageBox(0,"face-corners",nspac,OUCH);
int i; if(v) if(qq!=pts) for(i=0;i<nf;i++) if(fac[i].q) fac[i].q=pts+(fac[i].q-qq); return !!v;}
/*-----*/
int mesh::setnf_  (int x,int k) {int i=(k?x==nf_  :x<=nf_  )?1:FR(fac  ,Face ,nf_=x,"fac")!=0;
if(!i) if(x) MessageBox(0,"faces",nspac,OUCH); return i;}
/*-----*/
int mesh::setng_  (int x,int k) {int i=(k?x==ng_  :x<=ng_  )?1:FR(group,Group,ng_=x,"group")!=0;
if(!i) if(x) MessageBox(0,"groups",nspac,OUCH); return i;}
/*-----*/
int mesh::setntma_(int x,int k) {int i=(k?x==ntma_:x<=ntma_)?1:FR(tma  ,Tma,ntma_=x,"tma")!=0;
if(!i) if(x) MessageBox(0,"texture map areas",nspac,OUCH); return i;}
/*-----*/
int mesh::setnprt_(int x,int k) {int i=(k?x==nprt_:x<=nprt_)?1:FR(prt  ,Prt,nprt_=x,"prt")!=0;
if(!i) if(x) MessageBox(0,"parts",nspac,OUCH); return i;}
/*-----*/
int mesh::setnmat_(int x,int k) {int i=(k?x==nmat_:x<=nmat_)?1:FR(mat  ,Mat,nmat_=x,"mat")!=0;
if(!i) if(x) MessageBox(0,"materials",nspac,OUCH); return i;}
/*-----*/
long mesh::addpoint(xyz P,int r){if(!setnp_(np+1)) return 0; altered=1;
point[np].a=r?fromscr(P):P; point[np].r=r?P:toscr(P); return np++;}
/*-----*/
long mesh::findaddpoint(xyz p){reg long i,N=np; reg Point*Q=point;
for(i=0;i<N;i++) if(p==Q[i].a) return i; altered=1; return addpoint(p);}
/*----*/
void Face::setprops(mesh*OB){c=2; mat=OB->currentmat; g=OB->currentgroup; tma=0; prt=0;
if(mat<0) mat=0; if(g<0) g=0; memset(q,0,n*sizeof(fcinfo)); OB->altered=1;}
/*----*/
Face*mesh::addface(int n){altered=1;
if(currentgroup<0?1:currentgroup>=ng) currentgroup=0; if(!ng) addgroup("default");
if(currentmat<0?1:currentmat>=nmat) currentmat=0;     if(!nmat) addmat("default");
if(!ntma) addtma(); if(!nprt) addprt(); if(!setnq_(nq+n) ?1: !setnf_(nf+1)) return 0;;
Face&f=fac[nf++]; f.q=pts+nq; nq+=n; f.n=n; f.setprops(this); return &f;}
/*-----*/
Face*mesh::addface(fcinfo&A,fcinfo&B,fcinfo&C,Face*F){altered=1;
setnq_(nq+3); setnf_(nf+1); Face*G=fac+nf++; G->n=3; G->q=pts+nq; nq+=3; if(!G) return 0;
fcinfo*Q=G->q; Q[0]=A; Q[1]=B; Q[2]=C; *G<<*F; return G;}
/*-----*/
Face*mesh::addface(Point**PP,int n,int check) {long i,k; Face*f=addface(n);
// if(check) weed out successive identical corners
if(check) while(n<2?0:PP[0]==PP[n-1]) n--; fcinfo*QQ=f->q,*R;
for(k=i=0;i<n;i++) if(!check ?1: !i ?1: PP[i]!=PP[k-1]) {
	 R=&QQ[k++]; if(PP) R->p=PP[i]; R->c=2; R->d=0; R->t=0;} f->n=k; return f;}
/*-----*/
Face*mesh::addface(fcinfo*PP,int n) {Face*f=addface(n); int i;
if(PP) for(i=0;i<n;i++) f->q[i]=PP[i]; return f;}
/*-----*/
long mesh::addmat(char*s){if(!setnmat_(nmat+1)) return 0; altered=1;
Mat&q=mat[nmat]; q.rename(s?s:""); q.vis=1; q.n=-1; return nmat++;}
/*-----*/
long mesh::findaddmat(char*s){int i; altered=1;
if(s) for(i=0;i<nmat;i++) if(!strcmp(s,mat[i].name)) return i; return addmat(s);}
/*-----*/
long mesh::addgroup(char*s){if(!setng_(ng+1)) return 0; altered=1;
setmem(group+ng,sizeof(Group),0); group[ng].rename(s?s:""); group[ng].vis=1; return ng++;}
/*-----*/
long mesh::findaddgroup(char*s){long i; altered=1;
if(s) for(i=0;i<ng;i++) if(!strcmp(s,group[i].name)) return i; return addgroup(s);}
/*-----*/
char*mesh::curgrpname(){int i=currentgroup; char*s=(i>=0?i<ng  :0)?group[i].name:"default";
return s?s:"_default";}
/*-----*/
char*mesh::curmatname(){int i=currentmat;   char*s=(i>=0?i<nmat:0)?mat  [i].name:"default";
return s?s:"_default";}
/*-----*/
void Group::rename(char*s){strncpy(name,s,32); name[31]=0;}
/*-----*/
void Mat::rename(char*s){strncpy(name,s,32); name[31]=0;}
/*-----*/
long mesh::addtma(){if(!setntma_(ntma+1)) return 0;; Tma&q=tma[ntma]; q.vis=1; return ntma++;}
/*-----*/
long mesh::addprt(){if(!setnprt_(nprt+1)) return 0;; Prt&q=prt[nprt]; q.vis=1; return nprt++;}
/*-----*/
long mesh::addd(xyz v){setnd_(nd+1); d[nd]=v; altered=1; return nd++;}
/*-----*/
long mesh::findaddd(xyz p){long i; for(i=0;i<nd;i++) if(p==d[i]) return i; return addd(p);}
/*-----*/
long mesh::addt(xy v){if(!setnt_(nt+1)) return 0;; t[nt].a=v; t[nt].s=1; altered=1; return nt++;}
/*-----*/
long mesh::findaddt(xy v){long i; for(i=0;i<nt;i++) if(v==t[i].a) return i; return addt(v);}
/*----------*/
//void mesh::colorsep(){long i,j; COLORREF c;
//for(i=0;i<nmat;i++) {LOOP: c=mat[i].KdColor;
//	 for(j=0;j<i;j++) if(c==mat[j].KdColor) {mat[i].KdColor=(c+1)&0x00ffffff; goto LOOP;}}}
/*-----*/
double arg(xyz W,int t){switch(t) {
case 0: default: return W.rr();
case 1: return W.x*W.x+W.y*W.y;
case 2: return W.z*W.z+W.y*W.y;}}
/*-----*/
double arg(xyz V,xyz W,int t){switch(t) {
case 0: default: return V.x*W.x+V.y*W.y+V.z*W.z;
case 1: return V.x*W.x+V.y*W.y;
case 2: return V.z*W.z+V.y*W.y;}}
/*-----*/
double mesh::xyarea(Face*F,xyz*p){int i,j=F->n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=p[F->q[i].p-point]; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].x-u[i].x)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double mesh::zyarea(Face*F,xyz*p){int i,j=F->n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=p[F->q[i].p-point]; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double mesh::zxarea(Face*F,xyz*p){int i,j=F->n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=p[F->q[i].p-point]; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].x+u[i].x); FF(u); return -a/2;}
/*-----*/
double Face::xyarea(){int i,j=n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=q[i].p->r; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].x-u[i].x)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double Face::zyarea(){int i,j=n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=q[i].p->r; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double Face::zxarea(){int i,j=n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=q[i].p->r; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].x+u[i].x); FF(u); return -a/2;}
/*-----*/
double Face::uvarea(){int i,j=n; double a=0; xy*u=FM(xy,j+1);
for(i=0;i<j;i++) u[i]=q[i].t?q[i].t->a:xy(0,0); u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].x-u[i].x)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
void Face::turn(){int i,j=n/2,k=n-1; fcinfo Z,*I=q;
if(I) for(i=0;i<j;i++) {Z=I[i]; I[i]=I[k-i]; I[k-i]=Z;}}
/*-----*/
int Face::operator==(Face&F){int i,j; if(n!=F.n?1:!q?1:!F.q) return 0;
for(i=0;i<n;i++) {for(j=0;j<n;j++) if(q[j].p!=F.q[(j+i)%n].p) goto F1; return 1; F1:}
for(i=0;i<n;i++) {for(j=0;j<n;j++) if(q[j].p!=F.q[(n-j+i)%n].p) goto F2; return 1; F2:;} return 0;}
/*-----*/
inline double det(
  double a,double b,double c,double d,double e,double f,double g,double h,double i) {
return a*(e*i-f*h)+b*(f*g-d*i)+c*(d*h-e*g);}
/*-----*/
xyz dircos(xyz A,xyz B,xyz C){
double x=det(  1,A.y,A.z,   1,B.y,B.z,   1,C.y,C.z);
double y=det(A.x,  1,A.z, B.x,  1,B.z, C.x,  1,C.z);
double z=det(A.x,A.y,  1, B.x,B.y,  1, C.x,C.y,  1),r=sqrt(x*x+y*y+z*z);
return xyz(x,y,z)*(r?1/r:1);}
/*-----*/
double scprod(xyz a,xyz b){return a.x*b.x+a.y*b.y+a.z*b.z;}
/*-----*/
static double pi=0;
/*-----*/
double pythag(xyz C,xyz P,xyz E) {double pc=(P-C).rr(),pe=(P-E).rr(),r;
if(!pc?1:!pe) return pi; r=(pc+pe-(C-E).rr())/2/sqrt(pc*pe);
return acos(r<-1?-1:r>1?1:r);}
/*-----*/
double dihedral(xyz A,xyz B,xyz C,xyz D) {double w; if(!pi) pi=4*atan(1.);
//char E[256]; sprintf(E,"{%g,%g,%g),{%g,%g,%g),{%g,%g,%g),{%g,%g,%g)",
//  A.x,A.y,A.z, B.x,B.y,B.z, C.x,C.y,C.z, D.x,D.y,D.z); MessageBox(0,E,"dihedral",OUCH);
double r=(B-A).rr(); if(!r) return 0;
double p=scprod(B-A,B-C)/r,q=scprod(B-A,B-D)/r;
xyz P=A*p+B*(1-p),Q=A*q+B*(1-q);
w=fabs(180-pythag(C,P,D+P-Q)*180/pi); while(w>180) w-=360;
//FILE*F=fopen("d:\\b\\makeobj\\______.cpp","a"); fprintf(F,"dih=%g\n",w); fflush(F); fclose(F);
return fabs(w);}
//xyz P=dircos(A,B,C),Q=dircos(A,B,D); double pi=4*atan(1.),x;
//x=(P-Q).r()/2; return !P.rr() ?0: !Q.rr() ?0: 180-180/pi*2*asin(x<-1?-1:x>1?1:x);
/*-----*/
int countOBJ(char*file,long&NF,long&NQ,long&NP,long&NT,long&ND,long&NG,long&NMAT){
FILE*G=fopen(file,"rb"); long i,j,M,N; char L[128],*P[128],Eof;
if(!G) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
LOOP: for(i=0;i<127;i++) {j=L[i]=fgetc(G); Eof=feof(G); if(Eof?1:j==10?1:j==13) break;}
N=i; L[i]=0; if(Eof) goto END; for(i=0;i<N;i++) if(L[i]<0?0:L[i]<=32) L[i]=0;
while(!N?0:!L[N-1]) N--; if(!N) goto LOOP; if(L[0]) {M=1; P[0]=L;} else M=0;
for(i=1;i<N;i++) if(L[i]) if(!L[i-1]) P[M++]=&L[i]; if(M<2) goto LOOP; /* find components */
if(!stricmp(P[0],"v")) {/* vertex */ NP++; goto LOOP;}
if(!stricmp(P[0],"vt")) {NT++; goto LOOP;} /*texture*/
if(!stricmp(P[0],"vn")) {/* normal */ ND++; goto LOOP;}
if(!stricmp(P[0],"f")) {NF++; NQ+=M; /* face */ goto LOOP;}
if(!stricmp(P[0],"g")) {NG++; goto LOOP;}
//if(!stricmp(P[0],"actor")) {NG++; goto LOOP;}
if(!stricmp(P[0],"usemtl")) NMAT++; goto LOOP;
END: fclose(G); return 1;}
/*-----*/
int mesh::readOBJ(char*file,int append){long i,j,M,N,v,T,D,C=0,NF,NQ,NP,NT,ND,NG,NMAT;
double x,y,z,LL; char a,L[1024],*P[1024],*V,Eof=0,Z[32],*bad; Face*F; fcinfo*I;
if(!append) initialize(1);
{TempTitle M(Wn,"I am counting the vertexes etc in the file");
    NF=nf; NQ=nq; NP=np; NT=nt; ND=nd; NG=ng; NMAT=nmat; countOBJ(file,NF,NQ,NP,NT,ND,NG,NMAT);}
FILE*G=fopen(file,"rb"); if(!G) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
long dnt=append?nt:0,dnd=append?nd:0,dnp=append?np:0;
if(!setnf_(NF) ?1: !setnq_(NQ) ?1: !setnp_(NP) ?1: !setnt_(NT) ?1: !setnd_(ND) ?1: !setng_(NG)
  ?1: !setnmat_(NMAT)) return 0;
LOOP: for(i=0;i<1023;i++) {j=L[i]=fgetc(G); Eof=Eof?1:feof(G); if(Eof?1:j==10?1:j==13) break;}
N=i; L[i]=0; LL=i;
if(Eof) goto END; for(i=0;i<N;i++) if(L[i]<0?0:L[i]<=32) L[i]=0;
while(!N?0:!L[N-1]) N--; if(!N) goto LOOP; C++;
if(L[0]) {M=1; P[0]=L;} else M=0;
for(i=1;i<N;i++) if(L[i]) if(!L[i-1]) P[M++]=&L[i]; if(M<2) goto LOOP; M--; /* find components */
if(!stricmp(P[0],"v")) {bad="<3 args"; if(M<3) goto BAD; /* vertex */
    x=atof(P[1]); y=atof(P[2]); z=atof(P[3]); addpoint(xyz(x,y,z)); goto LOOP;}
if(!stricmp(P[0],"vt")) {bad="<2 args"; if(M<2) goto BAD;
    x=atof(P[1]); y=M<2?0:atof(P[2]); addt(xy(x,y)); goto LOOP;} /*texture*/
if(!stricmp(P[0],"vn")) {bad="<3 args"; if(M<3) goto BAD; /* normal */
    x=atof(P[1]); y=atof(P[2]); z=atof(P[3]); addd(xyz(x,y,z)); goto LOOP;}
if(!stricmp(P[0],"f")) {F=addface(M); /* face */
    if(F) for(I=F->q,i=1;i<=M;i++) {T=D=0; V=P[i]; sscanf(V,"%ld",&v);
        for(j=0;a=V[j],a;j++) if(a=='/') break; if(a) if(!sscanf(V+=j+1,"%ld",&T)) T=0;
        for(j=0;a=V[j],a;j++) if(a=='/') break; if(a) if(!sscanf(V+=j+1,"%ld",&D)) D=0;
        if(v<0) v+=np+1; else v+=dnp; bad="no such vertex";  if(v<1?1:v>np) goto BAD;
        if(T<0) T+=nt+1; else T+=dnt; if(T<0?1:T>nt) T=1;
        if(D<0) D+=nd+1; else D+=dnd; bad="no such normal"; if(D<0?1:D>nd) goto BAD;
        I[i-1].p=&point[v-1]; I[i-1].t=T?&t[T-1]:0; I[i-1].d=D?&d[D-1]:0;}
    goto LOOP;}
if(!stricmp(P[0],"mtllib")) {if(!mtllib) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
    i=strlen(P[1]); strcpy(mtllib=FM(char,i+1),P[1]);}} else
if(!stricmp(P[0],"g")) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
    currentgroup=findaddgroup(P[1]);} else
if(!stricmp(P[0],"actor")) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
    j=strlen(P[1]); for(i=0;i<j;i++) if(P[1][i]==':') break; P[1][i]=0;
    currentgroup=findaddgroup(P[1]); dnt=nt; dnd=nd; dnp=np;} else
if(!stricmp(P[0],"usemtl")) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
	 currentmat=findaddmat(P[1]);} goto LOOP;
END: fclose(G); i=1; goto EXIT;
BAD: fclose(G); sprintf(Z,"line %d is bad: %s",C,bad); for(i=0;i<N;i++) if(!L[i]) L[i]=' ';
MessageBox(0,L,Z/*file*/,OUCH); i=0;
EXIT:
setnf_(nf,1); setnq_(nq,1); setnp_(np,1); setnt_(nt,1); setnd_(nd,1); setng_(ng,1);
setnmat_(nmat,1); setntma_(ntma,1); setnprt_(nprt,1); return i;}
/*-----*/
#define fflush(H)
int mesh::writeOBJ(char*fn,int special){int Np=0,Nt=0,Nd=0,lmat=-1,k; xyz u;
if(special&1) {Np=np+1; Nt=nt+1; Nd=nd+1;} /* in v lines, all v vn vt numbers to be relative */
FILE*H=fopen(fn,"w"); if(!H) return 0;
long g,i,j,maxn; Face*F,*FL; fcinfo*I;
maxn=0; forallface() if(F->n<maxn) maxn=F->n;
fprintf(H,"# File generated by FACES\n"); fflush(H);
fprintf(H,"# NumFacets/MaxNumEdges   %d/%d\n",nf,maxn); fflush(H);
fprintf(H,"# NumVerts/NumTVerts/NumVNormals   %d/%d/%d\n",np,nt,nd); fflush(H);
if(mtllib) fprintf(H,"mtllib %s\n",mtllib);
for(i=0;i<np;i++) {u=point[i].a; fprintf(H,"v %6g %6g %6g\n",u.x,u.y,u.z); fflush(H);}
for(i=0;i<nt;i++) {fprintf(H,"vt %6g %6g\n",t[i].a.x,t[i].a.y); fflush(H);}
for(i=0;i<nd;i++) {fprintf(H,"vn %6g %6g %6g\n",d[i].x,d[i].y,d[i].z); fflush(H);}
for(k=0;k<ng;k++) {g=1;
	 forallface() if(F->g==k) {
		  if(g) {fprintf(H,"g %s\n",group[k].name); g=0; fflush(H);}
		  if(lmat!=F->mat) fprintf(H,"usemtl %s\n",mat[lmat=F->mat].name); fflush(H);
		  fprintf(H,"f");
		  for(j=0;j<F->n;j++) {Point*P=I[j].p; Texp*T=I[j].t; xyz*D=I[j].d;
				fprintf(H," %ld",long(P-point)+1-Np);
				if(!D) {if(T) fprintf(H,"/%ld",long(T-t)+1-Nt);}
				else {if(!T) fprintf(H,"//%ld",long(D-d)+1-Nd);
					 else fprintf(H,"/%ld/%ld",long(T-t)+1-Nt,long(D-d)+1-Nd);}}
		  fprintf(H,"\n"); fflush(H);
		  if(special&2) {fscanf(H,"##");
            for(j=0;j<F->n;j++) {u=I[j].p->a; fprintf(H," / %g,%g,%g",u.x,u.y,u.z);}
				fscanf(H,"\n",1); fflush(H);}}}
fclose(H); return 1;}
/*-----*/
